unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Button4: TButton;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    procedure PreProcess;
    procedure PostProcess;
    function getCurHandle: Integer;
    function GetTListBoxInfo(h: Hwnd): String;
    function GetTComboBoxInfo(h: Hwnd): String;    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  function EnumChildProc(h: Hwnd;  a: integer): Boolean; stdcall;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  h: HWND;
begin
  PreProcess;
  h:=FindWindow(nil, PChar(Edit1.Text));
  if h <> 0 then
  begin
    EnumChildWindows(h, @EnumChildProc, 0);
  end;
  PostProcess;
end;

function EnumChildProc(h: hwnd;  a: integer): Boolean; stdcall;
var
  str: Array[0..1024] of Char;
  rect: TRect;
begin
  Result := true;
  if h <> 0 then
  begin
    GetClassName(h, str, 1024);
    Form1.Memo1.Lines.Add('handle='+inttostr(h)+'      classname='+str);
    Form1.ComboBox1.Items.Add(IntToStr(h)+' '+str);    
    if GetWindowRect(h, rect) then
      Form1.Memo1.Lines.Add('screen boundary=('+inttostr(rect.Left)+','+inttostr(rect.Top)+'),('+inttostr(rect.Right)+','+inttostr(rect.Bottom)+')');
    if GetClientRect(h, rect) then
      Form1.Memo1.Lines.Add('client area boundary=('+inttostr(rect.Left)+','+inttostr(rect.Top)+'),('+inttostr(rect.Right)+','+inttostr(rect.Bottom)+')');

  // BzӧOe
    if str = 'TListBox' then
      Form1.Memo1.Lines.Add(Form1.GetTListBoxInfo(h))
    else if str = 'TComboBox' then
      Form1.Memo1.Lines.Add(Form1.GetTComboBoxInfo(h));

  // ore
    SendMessage(h, WM_GETTEXT, 1024, integer(@str[0]));
    Form1.Memo1.Lines.Add('gettext='+str);

    Form1.Memo1.Lines.Add('');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  str: Array[0..1024] of Char;
begin
  strPCopy(str, 'mytest');
  SendMessage(getCurHandle, WM_SETTEXT, 1024, integer(@str[0]));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SetWindowPos(getCurHandle, 0, 0, 0, 0, 0, SWP_NOSIZE + SWP_NOMOVE + SWP_NOZORDER + SWP_NOACTIVATE + SWP_HIDEWINDOW);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SetWindowPos(getCurHandle, 0, 0, 0, 0, 0, SWP_NOSIZE + SWP_NOMOVE + SWP_NOZORDER + SWP_NOACTIVATE + SWP_SHOWWINDOW);
end;

procedure TForm1.PostProcess;
begin
  Memo1.Lines.Add(#13#10#13#10'END FINDING!!');
end;

procedure TForm1.PreProcess;
begin
  Memo1.Lines.Clear;
  ComboBox1.Items.Clear;
  Memo1.Lines.Add('START TO FIND ['+Edit1.Text+']....'#13#10#13#10);
end;

function TForm1.getCurHandle: Integer;
var
  ilen: integer;
begin
  Result := 0;
  if ComboBox1.Text <> '' then
  begin
    ilen := Pos(' ', ComboBox1.Text) - 1;
    if ilen < 0 then ilen := length(ComboBox1.Text);
    try
      Result := StrToInt(Copy(ComboBox1.Text, 1, ilen));
    except
    end;
  end;
end;

function TForm1.GetTListBoxInfo(h: Hwnd): String;
var
  str: Array[0..1024] of Char;
  i: integer;
  bError: Boolean;
begin
  bError := false;
  i:=0;
  while not bError do
  begin
    if SendMessage(h, LB_GETTEXT, i, integer(@str[0])) <> LB_ERR then
    begin
      Result := Result + IntToStr(i) + '.(' + str + ') ';
      Inc(i);
    end
    else
      bError := true;
  end;
end;

function TForm1.GetTComboBoxInfo(h: Hwnd): String;
var
  str: Array[0..1024] of Char;
  i: integer;
  bError: Boolean;
begin
  bError := false;
  i:=0;
  while not bError do
  begin
    if SendMessage(h, CB_GETLBTEXT, i, integer(@str[0])) <> CB_ERR then
    begin
      Result := Result + IntToStr(i) + '.(' + str + ') ';
      Inc(i);
    end
    else
      bError := true;
  end;      
end;



end.
